/*!
 * \file      UpperTesterMapemSpatemFactory.hh
 * \brief     Header file for ITS MAPEM/SPATEM Upper Tester protocol layer factory.
 * \author    ETSI STF525
 * \copyright ETSI Copyright Notification
 *            No part may be reproduced except as authorized by written permission.
 *            The copyright and the foregoing restriction extend to reproduction in all media.
 *            All rights reserved.
 * \version   0.1
 */
#pragma once

#include "LayerStackBuilder.hh"

#include "UpperTesterMapemSpatemLayer.hh"

class UpperTesterMapemSpatemFactory : public LayerFactory {
  static UpperTesterMapemSpatemFactory _f;
public:
  UpperTesterMapemSpatemFactory() {
    // Register factory
    loggers::get_instance().log(">>> UpperTesterMapemSpatemFactory::UpperTesterMapemSpatemFactory");
    LayerStackBuilder::RegisterLayerFactory("UT_MAPEMSPATEM", this);
  };
  inline virtual Layer * createLayer(const std::string& p_type, const std::string& p_param){
    return new UpperTesterMapemSpatemLayer(p_type, p_param);
  };
}; // End of class UpperTesterMapemSpatemFactory
